<template>
  <div class="vr-video-container" ref="video">
    <iframe
      v-if="video !== null"
      id="vrFrame"
      ref="vr"
      style="z-index: 9999; width: 100%;"
      :style="{ height: height + 'px' }"
      :src="videoSrc"
      frameborder="0"
    ></iframe>
  </div>
</template>

<script>
export default {
  name: "vrVideo",
  props: {
    video: {
      type: String,
      default: () => null
    },
    hidden: {
      type: Boolean,
      default: () => false
    }
  },
  data() {
    return {
      height: "100%",
      canNext: false,
      step: -1,
      totalStep: 2,
      finish: null
      // test: 1
    };
  },
  computed: {
    videoSrc() {
      return process.env.NODE_ENV === "development"
        ? `http://127.0.0.1:3000${this.video}`
        : this.video;
    },
    muted() {
      let $iframe = document.getElementById("vrFrame");
      if ($iframe) {
        $iframe.muted = !this.hidden;
      }
      return false;
    }
  },
  methods: {
    getHeight(width) {
      let _width = width / 1280;
      this.height = 720 * _width;
    },
    onIframeEvents(ev) {
      if (this.step === -1 || this.hidden) return;
      if (this.step > 2) this.step = 1;
      // console.log(ev.data);
      switch (ev.data) {
        case "recordingStart":
          this.$emit("recordingStart");
          break;
        case "recordingEnd":
          this.$emit("recordingEnd");
          break;
        case "labOne":
          this.step = 1;
          this.$emit("finish", this.step);
          break;
        case "labTwo":
          this.step = 2;
          this.$emit("finish", this.step);
          break;
        default:
          if (ev.data.includes(",")) {
            this.$emit("next", ev.data.split(","));
          }
      }
    }
  },
  async mounted() {
    this.getHeight(1020);
    window.addEventListener("message", this.onIframeEvents, false);
    setTimeout(() => {
      this.step = 1;
    }, 5000);
  },
  async beforeDestroy() {
    window.removeEventListener("message", this.onIframeEvents);
  }
};
</script>

<style lang="scss" scoped>
.vr-video-container {
  width: 100%;
}
</style>
